
/* $Id: cpdtest.c,v 3.3 1999/02/24 15:41:35 kohl Exp $ */


/*
 *                      CUMULVS version 1.0:
 *      Computational Steering and Interactive Visualization
 *                   in Distributed Applications
 *           Oak Ridge National Laboratory, Oak Ridge TN.
 *      Authors:  James Arthur Kohl and Philip M. Papadopoulos
 *                   (C) 1996 All Rights Reserved
 *
 *                              NOTICE
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose and without fee is hereby granted
 * provided that the above copyright notice appear in all copies and
 * that both the copyright notice and this permission notice appear
 * in supporting documentation.
 *
 * Neither the Institution, Oak Ridge National Laboratory, nor the
 * Authors make any representations about the suitability of this
 * software for any purpose.  This software is provided ``as is''
 * without express or implied warranty.
 *
 * CUMULVS was funded by the U.S. Department of Energy.
 */


/* System Header Files */

#include <stdio.h>


/* STV Header Files */

#include "stv.h"
#include "stvmac.h"
#include "stv_glob.h"

#include <stdlib.h>


/* a main routine to test the reading and writing */

main()
{
char fname[25];
int fd;
int idata[4000];
float fdata[4000];
double ddata[4000];
CPD_HEADER header;
int ntasks, proclist[2048], i, j, idx;
long flen;

	strcpy(header.name, "stovepipe");
	printf("enter the file name: ");
	scanf("%s",fname);
	printf("enter the number of processors: ");
	scanf("%d",&ntasks);
	header.ntasks = ntasks;
    if ( (fd = cpd_open(fname, &flen))  <  0 )
	{
		printf(" could not open file %s \n", fname);
		exit(-1);
	}
	cpd_write_hdr(fd,&header);

	for ( i = 0; i < ntasks; i ++)
		proclist[i] = 0;
	for (i = 0; i < ntasks; i ++)
	{
		idx = (int) random();
	    idx = idx & 0xf;
		if (idx >= ntasks) idx = 0;
		while (proclist[idx] != 0)
		{
			idx ++;
			if (idx >= ntasks) idx = 0;
		}
		proclist[idx] = 1;
		for (j = 0; j < 4000; j ++)
		{
			idata[j] = idx +j;
			ddata[j] = (double)(idx +j);
			fdata[j] = (float)(idx +j);
		}
		cpd_node_data_buf(fd,idx);
		printf("Node %d \n",idx);
		write(fd,idata,4000*sizeof(int));
		write(fd,ddata,4000*sizeof(double));
		write(fd,fdata,4000*sizeof(float));
	}
    printf("done writing data \n");
	for (i = 0; i < ntasks; i ++)
	{
		printf("Read node %d \n",i);
		cpd_node_data_buf(fd,i);
		read(fd,idata,4000*sizeof(int));
		read(fd,ddata,4000*sizeof(double));
		read(fd,fdata,4000*sizeof(float));
		for (j = 0; j < 4000; j ++)
		{
			if (idata[j] != i +j) printf("error in idata for node %d \n",i);
			if (ddata[j] != (double)(i +j))
				 printf("error in ddata for node %d \n",i);
			if (fdata[j] != (float)(i +j)) 
				printf("error in fdata for node %d \n",i);
		}
		
	}
	close(fd);
	printf("input existing file from which to read data: ");
	scanf("%s",fname);
    if ( (fd = cpd_open(fname, &flen))  <  0 )
	{
		printf(" could not open file %s \n", fname);
		exit(-1);
	}
	printf("length of files in bytes is %ld \n", flen);
	cpd_read_header(fd,&header);
	printf("The number of procs in this file is %d \n",header.ntasks);
	for (i = 0; i < header.ntasks; i ++)
	{
		printf("Read node %d \n",i);
		cpd_node_data_buf(fd,i);
		read(fd,idata,4000*sizeof(int));
		read(fd,ddata,4000*sizeof(double));
		read(fd,fdata,4000*sizeof(float));
		for (j = 0; j < 4000; j ++)
		{
			if (idata[j] != i +j) printf("error in idata for node %d \n",i);
			if (ddata[j] != (double)(i +j))
				 printf("error in ddata for node %d \n",i);
			if (fdata[j] != (float)(i +j)) 
				printf("error in fdata for node %d \n",i);
		}
		
	}
	close(fd);
	
}	
