
/* $Id: flyme_glob.c,v 3.0 1996/08/23 22:06:22 kohl Exp $ */


/*
 *                      CUMULVS version 1.0:
 *      Computational Steering and Interactive Visualization
 *                   in Distributed Applications
 *           Oak Ridge National Laboratory, Oak Ridge TN.
 *      Authors:  James Arthur Kohl and Philip M. Papadopoulos
 *                   (C) 1996 All Rights Reserved
 *
 *                              NOTICE
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose and without fee is hereby granted
 * provided that the above copyright notice appear in all copies and
 * that both the copyright notice and this permission notice appear
 * in supporting documentation.
 *
 * Neither the Institution, Oak Ridge National Laboratory, nor the
 * Authors make any representations about the suitability of this
 * software for any purpose.  This software is provided ``as is''
 * without express or implied warranty.
 *
 * CUMULVS was funded by the U.S. Department of Energy.
 */


/* Flyme Globals Declarations */


#include "flyme.h"


/* STV Globals */

STV_VIEW_FIELD_GROUP CURRENT_VFG;

STV_VIEW_FIELD_GROUP RADAR_VFG;

STV_VIEW_FIELD CURRENT_VF;

STV_VIEW_PARAM CURRENT_VP;

STV_VIEWER VIEWER;

STV_REGION MAX_REGION;

STV_REGION VISREGION;

STV_CELL VISCELL;

double AUTO_ZOOM_FACTOR;

double ZOOM_FACTOR;

int ZOOM_LIMIT;

double RADAR_RANGE;

int RADAR_CHANGED;

int GRID_SPACING;

int HELI_RADIUS;

int INITIALIZED;

int CONNECTED;

int PLAY_MODE;

int BASE_SCORE;

int MY_SCORE;

int STEERING;

int RESTART;

int MYTID;

int FREQ;

int HEADING_GOAL_INDEX;
int VELOCITY_GOAL_INDEX;
int RADAR_RANGE_INDEX;
int FIRE_BULLET_INDEX;
int SHIELDED_INDEX;
int HELI_INDEX;
int RELEASE_INDEX;


/* TCL / TK Globals */

Tcl_Interp	*interp;

Tk_Window	Top;

Display		*Disp;

char	**Argv;
int 	Argc;


/* Heli Globals */

HELI	CURRENT_HELI;

WIN		RADAR_WIN;

WIN		MAIN_WIN;

REGION_STACK	REGIONS;

char	TMP_COORD1[255];
char	TMP_COORD2[255];
char	TMP_COORD3[255];
char	TMP_COORD4[255];

char	TMP_CMD[1024];

char	*FLYME_DIR;

char	*FM;
char	*FM_C;
char	*FM_R;
char	*FM_I;
char	*FM_IF;
char	*FM_IS;
char	*FM_IH;

int		STEER_RELEASE;

int		STEER_ACTIVE;

int		AUTO_STEER;

int		AUTO_ZOOM;

int		PTR_VALID;

int		PTR_X;
int		PTR_Y;

int		REGION_ID;

int		TIMER_INTERVAL;

int		ROTOR_CLICKS;

int		BORDER_SPACE;
int		FRAME_BORDER;
int		ROW_HEIGHT;
int		COL_WIDTH;

int		qflag;
int 	vflag;

